-- Author: Nerino1
-- Create Date : 9/10/2018
-- Version 8.0

local f=CreateFrame("frame");
f:RegisterEvent("PLAYER_LOGIN");
f:RegisterEvent("UNIT_INVENTORY_CHANGED");
f:RegisterEvent("AZERITE_EMPOWERED_ITEM_SELECTION_UPDATED");
f:RegisterEvent("BAG_UPDATE");
loaded = IsAddOnLoaded("Pawn");
loaded = IsAddOnLoaded("ElvUI_SLE");
local debug = false;

local function eventhandler(self,event)
	if event == "PLAYER_LOGIN" then
		DEFAULT_CHAT_FRAME:AddMessage("Artifact Button Loaded. - Consider Switching to my New Addon 'Azerite Button' for continued development.");
		if IsAddOnLoaded("ElvUI_SLE") then
			headbtn:SetPoint("BOTTOMLEFT", 57, 22)
			headbtn:SetWidth(10)
			headbtn:SetFrameStrata("HIGH")
			
			shoulderbtn:SetPoint("BOTTOMLEFT", 74, 22)
			shoulderbtn:SetWidth(10)
			shoulderbtn:SetFrameStrata("HIGH")
			
			chestbtn:SetPoint("BOTTOMLEFT", 90, 22)
			chestbtn:SetWidth(10)
			chestbtn:SetFrameStrata("HIGH")
			if debug == true then print("Debug - ElvUI S&L Installed"); end
		else
			headbtn:SetPoint("BOTTOMLEFT", 70, 10)
			headbtn:SetWidth(10)
			--framestrata variable in quotes so that the variable is not translated in non-english versions of the game.
			headbtn:SetFrameStrata("HIGH")
			
			shoulderbtn:SetPoint("BOTTOMLEFT", 87, 10)
			shoulderbtn:SetWidth(10)
			shoulderbtn:SetFrameStrata("HIGH")
			
			chestbtn:SetPoint("BOTTOMLEFT", 104, 10)
			chestbtn:SetWidth(10)
			chestbtn:SetFrameStrata("HIGH")
			if debug == true then print("Debug - ElvUI S&L Not Installed"); end
		end
		if IsAddOnLoaded("Pawn") then
			if debug == true then print("Debug - Pawn's On"); end
			btn:SetPoint("BOTTOMLEFT", 60, 10)
			btn:SetWidth(60)
		else
			btn:SetPoint("BOTTOMLEFT", 15, 10)
		end
		if UnitLevel("player") <= 97 then
			artifactbtn:Hide()
			headbtn:Hide()
			shoulderbtn:Hide()
			chestbtn:Hide()
			do return end
		elseif UnitLevel("player") <= 107 then
			headbtn:Hide()
			shoulderbtn:Hide()
			chestbtn:Hide()
		-- maybe i can check if the quest that makes you give up your artifact is complete
		elseif UnitLevel("player") >= 108 then
			artifactbtn:Hide()
			if debug == true then print("Debug - Artifact Button Disabled due to level");
		end
		buttonHightlight()

	elseif event == "UNIT_INVENTORY_CHANGED" then
		if debug == true then print("Debug - *Event* Unit_Inventory_Changed"); end
		buttonHightlight()
		
	elseif event == "AZERITE_EMPOWERED_ITEM_SELECTION_UPDATED" then
		if debug == true then print("Debug - *Event* Azerite_Empowered Item_Selection_Updated"); end
		buttonHightlight()
		
	--elseif event == "BAG_UPDATE" then
	--	if debug == true then print("Debug - *Event* Bag_Update"); end
	--	buttonHightlight()
	end
		-- DEFAULT_CHAT_FRAME:AddMessage("Artifact Button Loaded.");
	headbtn:SetPoint("BOTTOMLEFT", 70, 10)
	headbtn:SetWidth(10)
	
	shoulderbtn:SetPoint("BOTTOMLEFT", 87, 10)
	shoulderbtn:SetWidth(10)
	
	chestbtn:SetPoint("BOTTOMLEFT", 104, 10)
	chestbtn:SetWidth(10)
	end
end

f:SetScript("OnEvent",eventhandler);

btn = CreateFrame("Button", "artifactbtn", PaperDollFrame, "OptionsButtonTemplate");
btn:SetText("Artifact")
btn:SetScript("OnClick", function() QueryArtifact() end)

Hbtn = CreateFrame("Button", "headbtn", PaperDollFrame, "OptionsButtonTemplate");
Hbtn:SetText("H")
Hbtn:SetScript("OnClick", function() openHead() end)

Sbtn = CreateFrame("Button", "shoulderbtn", PaperDollFrame, "OptionsButtonTemplate");
Sbtn:SetText("S")
Sbtn:SetScript("OnClick", function() openShoulder() end)

Cbtn = CreateFrame("Button", "chestbtn", PaperDollFrame, "OptionsButtonTemplate");
Cbtn:SetText("C")
Cbtn:SetScript("OnClick", function() openChest() end)

function buttonHightlight()
	local itemLocation = ItemLocation:CreateFromEquipmentSlot(1);
		if C_Item.DoesItemExist(itemLocation) and C_AzeriteEmpoweredItem.IsAzeriteEmpoweredItem(itemLocation) then
			if C_AzeriteEmpoweredItem.HasAnyUnselectedPowers(itemLocation) then
				if debug == true then print("Debug - lock head"); end
				headbtn:LockHighlight()
			else
				if debug == true then print("Debug - unlock head"); end
				headbtn:UnlockHighlight()	
			end
		else
			if debug == true then print("unlock head - no azerite item"); end
			headbtn:UnlockHighlight()
		end
	
	local itemLocation = ItemLocation:CreateFromEquipmentSlot(3);
		if C_Item.DoesItemExist(itemLocation) and C_AzeriteEmpoweredItem.IsAzeriteEmpoweredItem(itemLocation) then
			if C_AzeriteEmpoweredItem.HasAnyUnselectedPowers(itemLocation) then
				if debug == true then print("Debug - lock shoulder"); end
				shoulderbtn:LockHighlight()
			else
				if debug == true then print("Debug - unlock shoulder"); end
				shoulderbtn:UnlockHighlight()	
			end
		else
			if debug == true then print("unlock shoulder - no azerite item"); end
			shoulderbtn:UnlockHighlight()
		end
		
	local itemLocationC = ItemLocation:CreateFromEquipmentSlot(5);
		if C_Item.DoesItemExist(itemLocationC) and C_AzeriteEmpoweredItem.IsAzeriteEmpoweredItem(itemLocationC) then
			if C_AzeriteEmpoweredItem.HasAnyUnselectedPowers(itemLocationC) then
				if debug == true then print("Debug - lock chest"); end
				chestbtn:LockHighlight()
			else
				if debug == true then print("Debug - unlock chest"); end
				chestbtn:UnlockHighlight()	
			end	
		else
			if debug == true then print("unlock chest - no azerite item"); end
			chestbtn:UnlockHighlight()
		end
end

function openArtifactWeapon()
    SocketInventoryItem(16);
end

function openHead()
	if debug == true then print("Debug - Head Click"); end
	local itemLocation = ItemLocation:CreateFromEquipmentSlot(1);
	if C_Item.DoesItemExist(itemLocation) then 
		if C_AzeriteEmpoweredItem.IsAzeriteEmpoweredItem(itemLocation) then
			OpenAzeriteEmpoweredItemUIFromItemLocation(itemLocation);
		else
			DEFAULT_CHAT_FRAME:AddMessage("Equipped head is not an Azerite item.");
			SocketInventoryItem(1);
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage("No head item is equipped.");
	end
end

function openShoulder()
	if debug == true then print("Debug - Shoulder Click"); end
	local itemLocation = ItemLocation:CreateFromEquipmentSlot(3);
	if C_Item.DoesItemExist(itemLocation) then 
		if C_AzeriteEmpoweredItem.IsAzeriteEmpoweredItem(itemLocation) then
			OpenAzeriteEmpoweredItemUIFromItemLocation(itemLocation);
		else
			DEFAULT_CHAT_FRAME:AddMessage("Equipped shoulder is not an Azerite item.");
			SocketInventoryItem(3);
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage("No shoulder item is equipped.");
	end
end

function openChest()
	if debug == true then print("Debug - Chest Click"); end
	local itemLocation = ItemLocation:CreateFromEquipmentSlot(5);
	if C_Item.DoesItemExist(itemLocation) then 
		if C_AzeriteEmpoweredItem.IsAzeriteEmpoweredItem(itemLocation) then
			OpenAzeriteEmpoweredItemUIFromItemLocation(itemLocation);
		else
			DEFAULT_CHAT_FRAME:AddMessage("Equipped chest is not an Azerite item.");
			SocketInventoryItem(5);
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage("No chest item is equipped.");
	end
end

function QueryArtifact()
    local QUALITY = {}
    QUALITY.POOR = 0;
    QUALITY.COMMON = 1;
    QUALITY.UNCOMMON = 2;
    QUALITY.RARE = 3;
    QUALITY.EPIC = 4;
    QUALITY.LEGENDARY = 5;
    QUALITY.ARTIFACT = 6;
    QUALITY.HEIRLOOM = 7;
    local currentWeapon = GetInventoryItemID("player", GetInventorySlotInfo("MainHandSlot"));
    if currentWeapon == nil then
        print("You do not have any weapon equipped.");
        return
    end
    name, link, quality, iLvl, reqLvl, class, subclass, maxStack, equipSlot, texture, vendorSellPrice = GetItemInfo(currentWeapon);
    if quality == QUALITY["ARTIFACT"] then
        openArtifactWeapon();
    else
        print("Currently equipped weapon is not an Artifact.");
    end
end